// WARNING - DO NOT EDIT THIS FILE:
// This file was automatically generated from scripts/ShTexCoord.hpp.py.
// If you wish to change it, edit that file instead.
//
// ---
//
// Sh: A GPU metaprogramming language.
//
// Copyright (c) 2003 University of Waterloo Computer Graphics Laboratory
// Project administrator: Michael D. McCool
// Authors: Zheng Qin, Stefanus Du Toit, Kevin Moule, Tiberiu S. Popa,
//          Michael D. McCool
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product documentation
// would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.
//////////////////////////////////////////////////////////////////////////////

#ifndef SH_SHTEXCOORD_HPP
#define SH_SHTEXCOORD_HPP

#include "ShAttrib.hpp"
namespace SH {

/** A texture coordinate.
 * 
 *
 */
template<int N, ShBindingType Binding, typename T=float, bool Swizzled=false>
class ShTexCoord : public ShAttrib<N, Binding, T, Swizzled> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = SH_TEXCOORD;

  typedef ShTexCoord<N, SH_INPUT, T> InputType;
  typedef ShTexCoord<N, SH_OUTPUT, T> OutputType;
  typedef ShTexCoord<N, SH_INOUT, T> InOutType;
  typedef ShTexCoord<N, SH_TEMP, T> TempType;
  typedef ShTexCoord<N, SH_CONST, T> ConstType;
  ShTexCoord();
  
  template<typename T2>
  ShTexCoord(const ShGeneric<N, T2>& other);
  ShTexCoord(const ShTexCoord<N, Binding, T, Swizzled>& other);
  
  template<typename T2>
  ShTexCoord(const ShTexCoord<N, Binding, T2, Swizzled>& other);
  ShTexCoord(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShTexCoord(host_type data[N]);
  
  ~ShTexCoord();

  
  template<typename T2>
  ShTexCoord& operator=(const ShGeneric<N, T2>& other);
  
  template<typename T2>
  ShTexCoord& operator=(const ShTexCoord<N, Binding, T2, Swizzled>& other);
  ShTexCoord& operator=(const ShTexCoord<N, Binding, T, Swizzled>& other);

  ShTexCoord& operator=(const ShProgram& prg);

  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<N, T2>& right);
  ShTexCoord& operator*=(host_type);
  ShTexCoord& operator/=(host_type);
  ShTexCoord& operator%=(host_type);
  ShTexCoord& operator+=(host_type);
  ShTexCoord& operator-=(host_type);
  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<1, T2>&);
  ShTexCoord<1, Binding, T, true> operator()(int) const;
  ShTexCoord<2, Binding, T, true> operator()(int, int) const;
  ShTexCoord<3, Binding, T, true> operator()(int, int, int) const;
  ShTexCoord<4, Binding, T, true> operator()(int, int, int, int) const;
  ShTexCoord<1, Binding, T, true> operator[](int) const;
  
  template<int N2>
  ShTexCoord<N2, Binding, T, true> swiz(int indices[]) const;
  
  ShTexCoord operator-() const;
  private:
    typedef ShAttrib<N, Binding, T, Swizzled> ParentType;
};

template<ShBindingType Binding, typename T, bool Swizzled>
class ShTexCoord<1, Binding, T, Swizzled> : public ShAttrib<1, Binding, T, Swizzled> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = SH_TEXCOORD;

  typedef ShTexCoord<1, SH_INPUT, T> InputType;
  typedef ShTexCoord<1, SH_OUTPUT, T> OutputType;
  typedef ShTexCoord<1, SH_INOUT, T> InOutType;
  typedef ShTexCoord<1, SH_TEMP, T> TempType;
  typedef ShTexCoord<1, SH_CONST, T> ConstType;
  ShTexCoord();
  
  template<typename T2>
  ShTexCoord(const ShGeneric<1, T2>& other);
  ShTexCoord(const ShTexCoord<1, Binding, T, Swizzled>& other);
  
  template<typename T2>
  ShTexCoord(const ShTexCoord<1, Binding, T2, Swizzled>& other);
  ShTexCoord(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShTexCoord(host_type data[1]);
  
  ShTexCoord(host_type);
  
  ~ShTexCoord();

  
  template<typename T2>
  ShTexCoord& operator=(const ShGeneric<1, T2>& other);
  
  template<typename T2>
  ShTexCoord& operator=(const ShTexCoord<1, Binding, T2, Swizzled>& other);
  ShTexCoord& operator=(const ShTexCoord<1, Binding, T, Swizzled>& other);

  ShTexCoord& operator=(host_type other);

  ShTexCoord& operator=(const ShProgram& prg);

  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<1, T2>& right);
  ShTexCoord& operator*=(host_type);
  ShTexCoord& operator/=(host_type);
  ShTexCoord& operator%=(host_type);
  ShTexCoord& operator+=(host_type);
  ShTexCoord& operator-=(host_type);
  ShTexCoord<1, Binding, T, true> operator()(int) const;
  ShTexCoord<2, Binding, T, true> operator()(int, int) const;
  ShTexCoord<3, Binding, T, true> operator()(int, int, int) const;
  ShTexCoord<4, Binding, T, true> operator()(int, int, int, int) const;
  ShTexCoord<1, Binding, T, true> operator[](int) const;
  
  template<int N2>
  ShTexCoord<N2, Binding, T, true> swiz(int indices[]) const;
  
  ShTexCoord operator-() const;
  private:
    typedef ShAttrib<1, Binding, T, Swizzled> ParentType;
};

template<ShBindingType Binding, typename T, bool Swizzled>
class ShTexCoord<2, Binding, T, Swizzled> : public ShAttrib<2, Binding, T, Swizzled> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = SH_TEXCOORD;

  typedef ShTexCoord<2, SH_INPUT, T> InputType;
  typedef ShTexCoord<2, SH_OUTPUT, T> OutputType;
  typedef ShTexCoord<2, SH_INOUT, T> InOutType;
  typedef ShTexCoord<2, SH_TEMP, T> TempType;
  typedef ShTexCoord<2, SH_CONST, T> ConstType;
  ShTexCoord();
  
  template<typename T2>
  ShTexCoord(const ShGeneric<2, T2>& other);
  ShTexCoord(const ShTexCoord<2, Binding, T, Swizzled>& other);
  
  template<typename T2>
  ShTexCoord(const ShTexCoord<2, Binding, T2, Swizzled>& other);
  ShTexCoord(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShTexCoord(host_type data[2]);
  
  ShTexCoord(host_type, host_type);
  template<typename T2, typename T3>
  ShTexCoord(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&);
  
  ~ShTexCoord();

  
  template<typename T2>
  ShTexCoord& operator=(const ShGeneric<2, T2>& other);
  
  template<typename T2>
  ShTexCoord& operator=(const ShTexCoord<2, Binding, T2, Swizzled>& other);
  ShTexCoord& operator=(const ShTexCoord<2, Binding, T, Swizzled>& other);

  ShTexCoord& operator=(const ShProgram& prg);

  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<2, T2>& right);
  ShTexCoord& operator*=(host_type);
  ShTexCoord& operator/=(host_type);
  ShTexCoord& operator%=(host_type);
  ShTexCoord& operator+=(host_type);
  ShTexCoord& operator-=(host_type);
  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<1, T2>&);
  ShTexCoord<1, Binding, T, true> operator()(int) const;
  ShTexCoord<2, Binding, T, true> operator()(int, int) const;
  ShTexCoord<3, Binding, T, true> operator()(int, int, int) const;
  ShTexCoord<4, Binding, T, true> operator()(int, int, int, int) const;
  ShTexCoord<1, Binding, T, true> operator[](int) const;
  
  template<int N2>
  ShTexCoord<N2, Binding, T, true> swiz(int indices[]) const;
  
  ShTexCoord operator-() const;
  private:
    typedef ShAttrib<2, Binding, T, Swizzled> ParentType;
};

template<ShBindingType Binding, typename T, bool Swizzled>
class ShTexCoord<3, Binding, T, Swizzled> : public ShAttrib<3, Binding, T, Swizzled> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = SH_TEXCOORD;

  typedef ShTexCoord<3, SH_INPUT, T> InputType;
  typedef ShTexCoord<3, SH_OUTPUT, T> OutputType;
  typedef ShTexCoord<3, SH_INOUT, T> InOutType;
  typedef ShTexCoord<3, SH_TEMP, T> TempType;
  typedef ShTexCoord<3, SH_CONST, T> ConstType;
  ShTexCoord();
  
  template<typename T2>
  ShTexCoord(const ShGeneric<3, T2>& other);
  ShTexCoord(const ShTexCoord<3, Binding, T, Swizzled>& other);
  
  template<typename T2>
  ShTexCoord(const ShTexCoord<3, Binding, T2, Swizzled>& other);
  ShTexCoord(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShTexCoord(host_type data[3]);
  
  ShTexCoord(host_type, host_type, host_type);
  template<typename T2, typename T3, typename T4>
  ShTexCoord(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&, const ShGeneric<1, T4>&);
  
  ~ShTexCoord();

  
  template<typename T2>
  ShTexCoord& operator=(const ShGeneric<3, T2>& other);
  
  template<typename T2>
  ShTexCoord& operator=(const ShTexCoord<3, Binding, T2, Swizzled>& other);
  ShTexCoord& operator=(const ShTexCoord<3, Binding, T, Swizzled>& other);

  ShTexCoord& operator=(const ShProgram& prg);

  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<3, T2>& right);
  ShTexCoord& operator*=(host_type);
  ShTexCoord& operator/=(host_type);
  ShTexCoord& operator%=(host_type);
  ShTexCoord& operator+=(host_type);
  ShTexCoord& operator-=(host_type);
  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<1, T2>&);
  ShTexCoord<1, Binding, T, true> operator()(int) const;
  ShTexCoord<2, Binding, T, true> operator()(int, int) const;
  ShTexCoord<3, Binding, T, true> operator()(int, int, int) const;
  ShTexCoord<4, Binding, T, true> operator()(int, int, int, int) const;
  ShTexCoord<1, Binding, T, true> operator[](int) const;
  
  template<int N2>
  ShTexCoord<N2, Binding, T, true> swiz(int indices[]) const;
  
  ShTexCoord operator-() const;
  private:
    typedef ShAttrib<3, Binding, T, Swizzled> ParentType;
};

template<ShBindingType Binding, typename T, bool Swizzled>
class ShTexCoord<4, Binding, T, Swizzled> : public ShAttrib<4, Binding, T, Swizzled> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = SH_TEXCOORD;

  typedef ShTexCoord<4, SH_INPUT, T> InputType;
  typedef ShTexCoord<4, SH_OUTPUT, T> OutputType;
  typedef ShTexCoord<4, SH_INOUT, T> InOutType;
  typedef ShTexCoord<4, SH_TEMP, T> TempType;
  typedef ShTexCoord<4, SH_CONST, T> ConstType;
  ShTexCoord();
  
  template<typename T2>
  ShTexCoord(const ShGeneric<4, T2>& other);
  ShTexCoord(const ShTexCoord<4, Binding, T, Swizzled>& other);
  
  template<typename T2>
  ShTexCoord(const ShTexCoord<4, Binding, T2, Swizzled>& other);
  ShTexCoord(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShTexCoord(host_type data[4]);
  
  ShTexCoord(host_type, host_type, host_type, host_type);
  template<typename T2, typename T3, typename T4, typename T5>
  ShTexCoord(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&, const ShGeneric<1, T4>&, const ShGeneric<1, T5>&);
  
  ~ShTexCoord();

  
  template<typename T2>
  ShTexCoord& operator=(const ShGeneric<4, T2>& other);
  
  template<typename T2>
  ShTexCoord& operator=(const ShTexCoord<4, Binding, T2, Swizzled>& other);
  ShTexCoord& operator=(const ShTexCoord<4, Binding, T, Swizzled>& other);

  ShTexCoord& operator=(const ShProgram& prg);

  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<4, T2>& right);
  ShTexCoord& operator*=(host_type);
  ShTexCoord& operator/=(host_type);
  ShTexCoord& operator%=(host_type);
  ShTexCoord& operator+=(host_type);
  ShTexCoord& operator-=(host_type);
  
  template<typename T2>
  ShTexCoord& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShTexCoord& operator%=(const ShGeneric<1, T2>&);
  ShTexCoord<1, Binding, T, true> operator()(int) const;
  ShTexCoord<2, Binding, T, true> operator()(int, int) const;
  ShTexCoord<3, Binding, T, true> operator()(int, int, int) const;
  ShTexCoord<4, Binding, T, true> operator()(int, int, int, int) const;
  ShTexCoord<1, Binding, T, true> operator[](int) const;
  
  template<int N2>
  ShTexCoord<N2, Binding, T, true> swiz(int indices[]) const;
  
  ShTexCoord operator-() const;
  private:
    typedef ShAttrib<4, Binding, T, Swizzled> ParentType;
};

typedef ShTexCoord<1, SH_INPUT, ShInterval<double> > ShInputTexCoord1i_d;
typedef ShTexCoord<1, SH_OUTPUT, ShInterval<double> > ShOutputTexCoord1i_d;
typedef ShTexCoord<1, SH_INOUT, ShInterval<double> > ShInOutTexCoord1i_d;
typedef ShTexCoord<1, SH_TEMP, ShInterval<double> > ShTexCoord1i_d;
typedef ShTexCoord<1, SH_CONST, ShInterval<double> > ShConstTexCoord1i_d;
typedef ShTexCoord<2, SH_INPUT, ShInterval<double> > ShInputTexCoord2i_d;
typedef ShTexCoord<2, SH_OUTPUT, ShInterval<double> > ShOutputTexCoord2i_d;
typedef ShTexCoord<2, SH_INOUT, ShInterval<double> > ShInOutTexCoord2i_d;
typedef ShTexCoord<2, SH_TEMP, ShInterval<double> > ShTexCoord2i_d;
typedef ShTexCoord<2, SH_CONST, ShInterval<double> > ShConstTexCoord2i_d;
typedef ShTexCoord<3, SH_INPUT, ShInterval<double> > ShInputTexCoord3i_d;
typedef ShTexCoord<3, SH_OUTPUT, ShInterval<double> > ShOutputTexCoord3i_d;
typedef ShTexCoord<3, SH_INOUT, ShInterval<double> > ShInOutTexCoord3i_d;
typedef ShTexCoord<3, SH_TEMP, ShInterval<double> > ShTexCoord3i_d;
typedef ShTexCoord<3, SH_CONST, ShInterval<double> > ShConstTexCoord3i_d;
typedef ShTexCoord<4, SH_INPUT, ShInterval<double> > ShInputTexCoord4i_d;
typedef ShTexCoord<4, SH_OUTPUT, ShInterval<double> > ShOutputTexCoord4i_d;
typedef ShTexCoord<4, SH_INOUT, ShInterval<double> > ShInOutTexCoord4i_d;
typedef ShTexCoord<4, SH_TEMP, ShInterval<double> > ShTexCoord4i_d;
typedef ShTexCoord<4, SH_CONST, ShInterval<double> > ShConstTexCoord4i_d;


typedef ShTexCoord<1, SH_INPUT, ShFracUShort> ShInputTexCoord1fus;
typedef ShTexCoord<1, SH_OUTPUT, ShFracUShort> ShOutputTexCoord1fus;
typedef ShTexCoord<1, SH_INOUT, ShFracUShort> ShInOutTexCoord1fus;
typedef ShTexCoord<1, SH_TEMP, ShFracUShort> ShTexCoord1fus;
typedef ShTexCoord<1, SH_CONST, ShFracUShort> ShConstTexCoord1fus;
typedef ShTexCoord<2, SH_INPUT, ShFracUShort> ShInputTexCoord2fus;
typedef ShTexCoord<2, SH_OUTPUT, ShFracUShort> ShOutputTexCoord2fus;
typedef ShTexCoord<2, SH_INOUT, ShFracUShort> ShInOutTexCoord2fus;
typedef ShTexCoord<2, SH_TEMP, ShFracUShort> ShTexCoord2fus;
typedef ShTexCoord<2, SH_CONST, ShFracUShort> ShConstTexCoord2fus;
typedef ShTexCoord<3, SH_INPUT, ShFracUShort> ShInputTexCoord3fus;
typedef ShTexCoord<3, SH_OUTPUT, ShFracUShort> ShOutputTexCoord3fus;
typedef ShTexCoord<3, SH_INOUT, ShFracUShort> ShInOutTexCoord3fus;
typedef ShTexCoord<3, SH_TEMP, ShFracUShort> ShTexCoord3fus;
typedef ShTexCoord<3, SH_CONST, ShFracUShort> ShConstTexCoord3fus;
typedef ShTexCoord<4, SH_INPUT, ShFracUShort> ShInputTexCoord4fus;
typedef ShTexCoord<4, SH_OUTPUT, ShFracUShort> ShOutputTexCoord4fus;
typedef ShTexCoord<4, SH_INOUT, ShFracUShort> ShInOutTexCoord4fus;
typedef ShTexCoord<4, SH_TEMP, ShFracUShort> ShTexCoord4fus;
typedef ShTexCoord<4, SH_CONST, ShFracUShort> ShConstTexCoord4fus;


typedef ShTexCoord<1, SH_INPUT, short> ShInputTexCoord1s;
typedef ShTexCoord<1, SH_OUTPUT, short> ShOutputTexCoord1s;
typedef ShTexCoord<1, SH_INOUT, short> ShInOutTexCoord1s;
typedef ShTexCoord<1, SH_TEMP, short> ShTexCoord1s;
typedef ShTexCoord<1, SH_CONST, short> ShConstTexCoord1s;
typedef ShTexCoord<2, SH_INPUT, short> ShInputTexCoord2s;
typedef ShTexCoord<2, SH_OUTPUT, short> ShOutputTexCoord2s;
typedef ShTexCoord<2, SH_INOUT, short> ShInOutTexCoord2s;
typedef ShTexCoord<2, SH_TEMP, short> ShTexCoord2s;
typedef ShTexCoord<2, SH_CONST, short> ShConstTexCoord2s;
typedef ShTexCoord<3, SH_INPUT, short> ShInputTexCoord3s;
typedef ShTexCoord<3, SH_OUTPUT, short> ShOutputTexCoord3s;
typedef ShTexCoord<3, SH_INOUT, short> ShInOutTexCoord3s;
typedef ShTexCoord<3, SH_TEMP, short> ShTexCoord3s;
typedef ShTexCoord<3, SH_CONST, short> ShConstTexCoord3s;
typedef ShTexCoord<4, SH_INPUT, short> ShInputTexCoord4s;
typedef ShTexCoord<4, SH_OUTPUT, short> ShOutputTexCoord4s;
typedef ShTexCoord<4, SH_INOUT, short> ShInOutTexCoord4s;
typedef ShTexCoord<4, SH_TEMP, short> ShTexCoord4s;
typedef ShTexCoord<4, SH_CONST, short> ShConstTexCoord4s;


typedef ShTexCoord<1, SH_INPUT, ShFracUInt> ShInputTexCoord1fui;
typedef ShTexCoord<1, SH_OUTPUT, ShFracUInt> ShOutputTexCoord1fui;
typedef ShTexCoord<1, SH_INOUT, ShFracUInt> ShInOutTexCoord1fui;
typedef ShTexCoord<1, SH_TEMP, ShFracUInt> ShTexCoord1fui;
typedef ShTexCoord<1, SH_CONST, ShFracUInt> ShConstTexCoord1fui;
typedef ShTexCoord<2, SH_INPUT, ShFracUInt> ShInputTexCoord2fui;
typedef ShTexCoord<2, SH_OUTPUT, ShFracUInt> ShOutputTexCoord2fui;
typedef ShTexCoord<2, SH_INOUT, ShFracUInt> ShInOutTexCoord2fui;
typedef ShTexCoord<2, SH_TEMP, ShFracUInt> ShTexCoord2fui;
typedef ShTexCoord<2, SH_CONST, ShFracUInt> ShConstTexCoord2fui;
typedef ShTexCoord<3, SH_INPUT, ShFracUInt> ShInputTexCoord3fui;
typedef ShTexCoord<3, SH_OUTPUT, ShFracUInt> ShOutputTexCoord3fui;
typedef ShTexCoord<3, SH_INOUT, ShFracUInt> ShInOutTexCoord3fui;
typedef ShTexCoord<3, SH_TEMP, ShFracUInt> ShTexCoord3fui;
typedef ShTexCoord<3, SH_CONST, ShFracUInt> ShConstTexCoord3fui;
typedef ShTexCoord<4, SH_INPUT, ShFracUInt> ShInputTexCoord4fui;
typedef ShTexCoord<4, SH_OUTPUT, ShFracUInt> ShOutputTexCoord4fui;
typedef ShTexCoord<4, SH_INOUT, ShFracUInt> ShInOutTexCoord4fui;
typedef ShTexCoord<4, SH_TEMP, ShFracUInt> ShTexCoord4fui;
typedef ShTexCoord<4, SH_CONST, ShFracUInt> ShConstTexCoord4fui;


typedef ShTexCoord<1, SH_INPUT, ShFracByte> ShInputTexCoord1fb;
typedef ShTexCoord<1, SH_OUTPUT, ShFracByte> ShOutputTexCoord1fb;
typedef ShTexCoord<1, SH_INOUT, ShFracByte> ShInOutTexCoord1fb;
typedef ShTexCoord<1, SH_TEMP, ShFracByte> ShTexCoord1fb;
typedef ShTexCoord<1, SH_CONST, ShFracByte> ShConstTexCoord1fb;
typedef ShTexCoord<2, SH_INPUT, ShFracByte> ShInputTexCoord2fb;
typedef ShTexCoord<2, SH_OUTPUT, ShFracByte> ShOutputTexCoord2fb;
typedef ShTexCoord<2, SH_INOUT, ShFracByte> ShInOutTexCoord2fb;
typedef ShTexCoord<2, SH_TEMP, ShFracByte> ShTexCoord2fb;
typedef ShTexCoord<2, SH_CONST, ShFracByte> ShConstTexCoord2fb;
typedef ShTexCoord<3, SH_INPUT, ShFracByte> ShInputTexCoord3fb;
typedef ShTexCoord<3, SH_OUTPUT, ShFracByte> ShOutputTexCoord3fb;
typedef ShTexCoord<3, SH_INOUT, ShFracByte> ShInOutTexCoord3fb;
typedef ShTexCoord<3, SH_TEMP, ShFracByte> ShTexCoord3fb;
typedef ShTexCoord<3, SH_CONST, ShFracByte> ShConstTexCoord3fb;
typedef ShTexCoord<4, SH_INPUT, ShFracByte> ShInputTexCoord4fb;
typedef ShTexCoord<4, SH_OUTPUT, ShFracByte> ShOutputTexCoord4fb;
typedef ShTexCoord<4, SH_INOUT, ShFracByte> ShInOutTexCoord4fb;
typedef ShTexCoord<4, SH_TEMP, ShFracByte> ShTexCoord4fb;
typedef ShTexCoord<4, SH_CONST, ShFracByte> ShConstTexCoord4fb;


typedef ShTexCoord<1, SH_INPUT, int> ShInputTexCoord1i;
typedef ShTexCoord<1, SH_OUTPUT, int> ShOutputTexCoord1i;
typedef ShTexCoord<1, SH_INOUT, int> ShInOutTexCoord1i;
typedef ShTexCoord<1, SH_TEMP, int> ShTexCoord1i;
typedef ShTexCoord<1, SH_CONST, int> ShConstTexCoord1i;
typedef ShTexCoord<2, SH_INPUT, int> ShInputTexCoord2i;
typedef ShTexCoord<2, SH_OUTPUT, int> ShOutputTexCoord2i;
typedef ShTexCoord<2, SH_INOUT, int> ShInOutTexCoord2i;
typedef ShTexCoord<2, SH_TEMP, int> ShTexCoord2i;
typedef ShTexCoord<2, SH_CONST, int> ShConstTexCoord2i;
typedef ShTexCoord<3, SH_INPUT, int> ShInputTexCoord3i;
typedef ShTexCoord<3, SH_OUTPUT, int> ShOutputTexCoord3i;
typedef ShTexCoord<3, SH_INOUT, int> ShInOutTexCoord3i;
typedef ShTexCoord<3, SH_TEMP, int> ShTexCoord3i;
typedef ShTexCoord<3, SH_CONST, int> ShConstTexCoord3i;
typedef ShTexCoord<4, SH_INPUT, int> ShInputTexCoord4i;
typedef ShTexCoord<4, SH_OUTPUT, int> ShOutputTexCoord4i;
typedef ShTexCoord<4, SH_INOUT, int> ShInOutTexCoord4i;
typedef ShTexCoord<4, SH_TEMP, int> ShTexCoord4i;
typedef ShTexCoord<4, SH_CONST, int> ShConstTexCoord4i;


typedef ShTexCoord<1, SH_INPUT, double> ShInputTexCoord1d;
typedef ShTexCoord<1, SH_OUTPUT, double> ShOutputTexCoord1d;
typedef ShTexCoord<1, SH_INOUT, double> ShInOutTexCoord1d;
typedef ShTexCoord<1, SH_TEMP, double> ShTexCoord1d;
typedef ShTexCoord<1, SH_CONST, double> ShConstTexCoord1d;
typedef ShTexCoord<2, SH_INPUT, double> ShInputTexCoord2d;
typedef ShTexCoord<2, SH_OUTPUT, double> ShOutputTexCoord2d;
typedef ShTexCoord<2, SH_INOUT, double> ShInOutTexCoord2d;
typedef ShTexCoord<2, SH_TEMP, double> ShTexCoord2d;
typedef ShTexCoord<2, SH_CONST, double> ShConstTexCoord2d;
typedef ShTexCoord<3, SH_INPUT, double> ShInputTexCoord3d;
typedef ShTexCoord<3, SH_OUTPUT, double> ShOutputTexCoord3d;
typedef ShTexCoord<3, SH_INOUT, double> ShInOutTexCoord3d;
typedef ShTexCoord<3, SH_TEMP, double> ShTexCoord3d;
typedef ShTexCoord<3, SH_CONST, double> ShConstTexCoord3d;
typedef ShTexCoord<4, SH_INPUT, double> ShInputTexCoord4d;
typedef ShTexCoord<4, SH_OUTPUT, double> ShOutputTexCoord4d;
typedef ShTexCoord<4, SH_INOUT, double> ShInOutTexCoord4d;
typedef ShTexCoord<4, SH_TEMP, double> ShTexCoord4d;
typedef ShTexCoord<4, SH_CONST, double> ShConstTexCoord4d;


typedef ShTexCoord<1, SH_INPUT, unsigned char> ShInputTexCoord1ub;
typedef ShTexCoord<1, SH_OUTPUT, unsigned char> ShOutputTexCoord1ub;
typedef ShTexCoord<1, SH_INOUT, unsigned char> ShInOutTexCoord1ub;
typedef ShTexCoord<1, SH_TEMP, unsigned char> ShTexCoord1ub;
typedef ShTexCoord<1, SH_CONST, unsigned char> ShConstTexCoord1ub;
typedef ShTexCoord<2, SH_INPUT, unsigned char> ShInputTexCoord2ub;
typedef ShTexCoord<2, SH_OUTPUT, unsigned char> ShOutputTexCoord2ub;
typedef ShTexCoord<2, SH_INOUT, unsigned char> ShInOutTexCoord2ub;
typedef ShTexCoord<2, SH_TEMP, unsigned char> ShTexCoord2ub;
typedef ShTexCoord<2, SH_CONST, unsigned char> ShConstTexCoord2ub;
typedef ShTexCoord<3, SH_INPUT, unsigned char> ShInputTexCoord3ub;
typedef ShTexCoord<3, SH_OUTPUT, unsigned char> ShOutputTexCoord3ub;
typedef ShTexCoord<3, SH_INOUT, unsigned char> ShInOutTexCoord3ub;
typedef ShTexCoord<3, SH_TEMP, unsigned char> ShTexCoord3ub;
typedef ShTexCoord<3, SH_CONST, unsigned char> ShConstTexCoord3ub;
typedef ShTexCoord<4, SH_INPUT, unsigned char> ShInputTexCoord4ub;
typedef ShTexCoord<4, SH_OUTPUT, unsigned char> ShOutputTexCoord4ub;
typedef ShTexCoord<4, SH_INOUT, unsigned char> ShInOutTexCoord4ub;
typedef ShTexCoord<4, SH_TEMP, unsigned char> ShTexCoord4ub;
typedef ShTexCoord<4, SH_CONST, unsigned char> ShConstTexCoord4ub;


typedef ShTexCoord<1, SH_INPUT, float> ShInputTexCoord1f;
typedef ShTexCoord<1, SH_OUTPUT, float> ShOutputTexCoord1f;
typedef ShTexCoord<1, SH_INOUT, float> ShInOutTexCoord1f;
typedef ShTexCoord<1, SH_TEMP, float> ShTexCoord1f;
typedef ShTexCoord<1, SH_CONST, float> ShConstTexCoord1f;
typedef ShTexCoord<2, SH_INPUT, float> ShInputTexCoord2f;
typedef ShTexCoord<2, SH_OUTPUT, float> ShOutputTexCoord2f;
typedef ShTexCoord<2, SH_INOUT, float> ShInOutTexCoord2f;
typedef ShTexCoord<2, SH_TEMP, float> ShTexCoord2f;
typedef ShTexCoord<2, SH_CONST, float> ShConstTexCoord2f;
typedef ShTexCoord<3, SH_INPUT, float> ShInputTexCoord3f;
typedef ShTexCoord<3, SH_OUTPUT, float> ShOutputTexCoord3f;
typedef ShTexCoord<3, SH_INOUT, float> ShInOutTexCoord3f;
typedef ShTexCoord<3, SH_TEMP, float> ShTexCoord3f;
typedef ShTexCoord<3, SH_CONST, float> ShConstTexCoord3f;
typedef ShTexCoord<4, SH_INPUT, float> ShInputTexCoord4f;
typedef ShTexCoord<4, SH_OUTPUT, float> ShOutputTexCoord4f;
typedef ShTexCoord<4, SH_INOUT, float> ShInOutTexCoord4f;
typedef ShTexCoord<4, SH_TEMP, float> ShTexCoord4f;
typedef ShTexCoord<4, SH_CONST, float> ShConstTexCoord4f;


typedef ShTexCoord<1, SH_INPUT, char> ShInputTexCoord1b;
typedef ShTexCoord<1, SH_OUTPUT, char> ShOutputTexCoord1b;
typedef ShTexCoord<1, SH_INOUT, char> ShInOutTexCoord1b;
typedef ShTexCoord<1, SH_TEMP, char> ShTexCoord1b;
typedef ShTexCoord<1, SH_CONST, char> ShConstTexCoord1b;
typedef ShTexCoord<2, SH_INPUT, char> ShInputTexCoord2b;
typedef ShTexCoord<2, SH_OUTPUT, char> ShOutputTexCoord2b;
typedef ShTexCoord<2, SH_INOUT, char> ShInOutTexCoord2b;
typedef ShTexCoord<2, SH_TEMP, char> ShTexCoord2b;
typedef ShTexCoord<2, SH_CONST, char> ShConstTexCoord2b;
typedef ShTexCoord<3, SH_INPUT, char> ShInputTexCoord3b;
typedef ShTexCoord<3, SH_OUTPUT, char> ShOutputTexCoord3b;
typedef ShTexCoord<3, SH_INOUT, char> ShInOutTexCoord3b;
typedef ShTexCoord<3, SH_TEMP, char> ShTexCoord3b;
typedef ShTexCoord<3, SH_CONST, char> ShConstTexCoord3b;
typedef ShTexCoord<4, SH_INPUT, char> ShInputTexCoord4b;
typedef ShTexCoord<4, SH_OUTPUT, char> ShOutputTexCoord4b;
typedef ShTexCoord<4, SH_INOUT, char> ShInOutTexCoord4b;
typedef ShTexCoord<4, SH_TEMP, char> ShTexCoord4b;
typedef ShTexCoord<4, SH_CONST, char> ShConstTexCoord4b;


typedef ShTexCoord<1, SH_INPUT, unsigned short> ShInputTexCoord1us;
typedef ShTexCoord<1, SH_OUTPUT, unsigned short> ShOutputTexCoord1us;
typedef ShTexCoord<1, SH_INOUT, unsigned short> ShInOutTexCoord1us;
typedef ShTexCoord<1, SH_TEMP, unsigned short> ShTexCoord1us;
typedef ShTexCoord<1, SH_CONST, unsigned short> ShConstTexCoord1us;
typedef ShTexCoord<2, SH_INPUT, unsigned short> ShInputTexCoord2us;
typedef ShTexCoord<2, SH_OUTPUT, unsigned short> ShOutputTexCoord2us;
typedef ShTexCoord<2, SH_INOUT, unsigned short> ShInOutTexCoord2us;
typedef ShTexCoord<2, SH_TEMP, unsigned short> ShTexCoord2us;
typedef ShTexCoord<2, SH_CONST, unsigned short> ShConstTexCoord2us;
typedef ShTexCoord<3, SH_INPUT, unsigned short> ShInputTexCoord3us;
typedef ShTexCoord<3, SH_OUTPUT, unsigned short> ShOutputTexCoord3us;
typedef ShTexCoord<3, SH_INOUT, unsigned short> ShInOutTexCoord3us;
typedef ShTexCoord<3, SH_TEMP, unsigned short> ShTexCoord3us;
typedef ShTexCoord<3, SH_CONST, unsigned short> ShConstTexCoord3us;
typedef ShTexCoord<4, SH_INPUT, unsigned short> ShInputTexCoord4us;
typedef ShTexCoord<4, SH_OUTPUT, unsigned short> ShOutputTexCoord4us;
typedef ShTexCoord<4, SH_INOUT, unsigned short> ShInOutTexCoord4us;
typedef ShTexCoord<4, SH_TEMP, unsigned short> ShTexCoord4us;
typedef ShTexCoord<4, SH_CONST, unsigned short> ShConstTexCoord4us;


typedef ShTexCoord<1, SH_INPUT, ShFracUByte> ShInputTexCoord1fub;
typedef ShTexCoord<1, SH_OUTPUT, ShFracUByte> ShOutputTexCoord1fub;
typedef ShTexCoord<1, SH_INOUT, ShFracUByte> ShInOutTexCoord1fub;
typedef ShTexCoord<1, SH_TEMP, ShFracUByte> ShTexCoord1fub;
typedef ShTexCoord<1, SH_CONST, ShFracUByte> ShConstTexCoord1fub;
typedef ShTexCoord<2, SH_INPUT, ShFracUByte> ShInputTexCoord2fub;
typedef ShTexCoord<2, SH_OUTPUT, ShFracUByte> ShOutputTexCoord2fub;
typedef ShTexCoord<2, SH_INOUT, ShFracUByte> ShInOutTexCoord2fub;
typedef ShTexCoord<2, SH_TEMP, ShFracUByte> ShTexCoord2fub;
typedef ShTexCoord<2, SH_CONST, ShFracUByte> ShConstTexCoord2fub;
typedef ShTexCoord<3, SH_INPUT, ShFracUByte> ShInputTexCoord3fub;
typedef ShTexCoord<3, SH_OUTPUT, ShFracUByte> ShOutputTexCoord3fub;
typedef ShTexCoord<3, SH_INOUT, ShFracUByte> ShInOutTexCoord3fub;
typedef ShTexCoord<3, SH_TEMP, ShFracUByte> ShTexCoord3fub;
typedef ShTexCoord<3, SH_CONST, ShFracUByte> ShConstTexCoord3fub;
typedef ShTexCoord<4, SH_INPUT, ShFracUByte> ShInputTexCoord4fub;
typedef ShTexCoord<4, SH_OUTPUT, ShFracUByte> ShOutputTexCoord4fub;
typedef ShTexCoord<4, SH_INOUT, ShFracUByte> ShInOutTexCoord4fub;
typedef ShTexCoord<4, SH_TEMP, ShFracUByte> ShTexCoord4fub;
typedef ShTexCoord<4, SH_CONST, ShFracUByte> ShConstTexCoord4fub;


typedef ShTexCoord<1, SH_INPUT, ShHalf> ShInputTexCoord1h;
typedef ShTexCoord<1, SH_OUTPUT, ShHalf> ShOutputTexCoord1h;
typedef ShTexCoord<1, SH_INOUT, ShHalf> ShInOutTexCoord1h;
typedef ShTexCoord<1, SH_TEMP, ShHalf> ShTexCoord1h;
typedef ShTexCoord<1, SH_CONST, ShHalf> ShConstTexCoord1h;
typedef ShTexCoord<2, SH_INPUT, ShHalf> ShInputTexCoord2h;
typedef ShTexCoord<2, SH_OUTPUT, ShHalf> ShOutputTexCoord2h;
typedef ShTexCoord<2, SH_INOUT, ShHalf> ShInOutTexCoord2h;
typedef ShTexCoord<2, SH_TEMP, ShHalf> ShTexCoord2h;
typedef ShTexCoord<2, SH_CONST, ShHalf> ShConstTexCoord2h;
typedef ShTexCoord<3, SH_INPUT, ShHalf> ShInputTexCoord3h;
typedef ShTexCoord<3, SH_OUTPUT, ShHalf> ShOutputTexCoord3h;
typedef ShTexCoord<3, SH_INOUT, ShHalf> ShInOutTexCoord3h;
typedef ShTexCoord<3, SH_TEMP, ShHalf> ShTexCoord3h;
typedef ShTexCoord<3, SH_CONST, ShHalf> ShConstTexCoord3h;
typedef ShTexCoord<4, SH_INPUT, ShHalf> ShInputTexCoord4h;
typedef ShTexCoord<4, SH_OUTPUT, ShHalf> ShOutputTexCoord4h;
typedef ShTexCoord<4, SH_INOUT, ShHalf> ShInOutTexCoord4h;
typedef ShTexCoord<4, SH_TEMP, ShHalf> ShTexCoord4h;
typedef ShTexCoord<4, SH_CONST, ShHalf> ShConstTexCoord4h;


typedef ShTexCoord<1, SH_INPUT, ShInterval<float> > ShInputTexCoord1i_f;
typedef ShTexCoord<1, SH_OUTPUT, ShInterval<float> > ShOutputTexCoord1i_f;
typedef ShTexCoord<1, SH_INOUT, ShInterval<float> > ShInOutTexCoord1i_f;
typedef ShTexCoord<1, SH_TEMP, ShInterval<float> > ShTexCoord1i_f;
typedef ShTexCoord<1, SH_CONST, ShInterval<float> > ShConstTexCoord1i_f;
typedef ShTexCoord<2, SH_INPUT, ShInterval<float> > ShInputTexCoord2i_f;
typedef ShTexCoord<2, SH_OUTPUT, ShInterval<float> > ShOutputTexCoord2i_f;
typedef ShTexCoord<2, SH_INOUT, ShInterval<float> > ShInOutTexCoord2i_f;
typedef ShTexCoord<2, SH_TEMP, ShInterval<float> > ShTexCoord2i_f;
typedef ShTexCoord<2, SH_CONST, ShInterval<float> > ShConstTexCoord2i_f;
typedef ShTexCoord<3, SH_INPUT, ShInterval<float> > ShInputTexCoord3i_f;
typedef ShTexCoord<3, SH_OUTPUT, ShInterval<float> > ShOutputTexCoord3i_f;
typedef ShTexCoord<3, SH_INOUT, ShInterval<float> > ShInOutTexCoord3i_f;
typedef ShTexCoord<3, SH_TEMP, ShInterval<float> > ShTexCoord3i_f;
typedef ShTexCoord<3, SH_CONST, ShInterval<float> > ShConstTexCoord3i_f;
typedef ShTexCoord<4, SH_INPUT, ShInterval<float> > ShInputTexCoord4i_f;
typedef ShTexCoord<4, SH_OUTPUT, ShInterval<float> > ShOutputTexCoord4i_f;
typedef ShTexCoord<4, SH_INOUT, ShInterval<float> > ShInOutTexCoord4i_f;
typedef ShTexCoord<4, SH_TEMP, ShInterval<float> > ShTexCoord4i_f;
typedef ShTexCoord<4, SH_CONST, ShInterval<float> > ShConstTexCoord4i_f;


typedef ShTexCoord<1, SH_INPUT, ShFracShort> ShInputTexCoord1fs;
typedef ShTexCoord<1, SH_OUTPUT, ShFracShort> ShOutputTexCoord1fs;
typedef ShTexCoord<1, SH_INOUT, ShFracShort> ShInOutTexCoord1fs;
typedef ShTexCoord<1, SH_TEMP, ShFracShort> ShTexCoord1fs;
typedef ShTexCoord<1, SH_CONST, ShFracShort> ShConstTexCoord1fs;
typedef ShTexCoord<2, SH_INPUT, ShFracShort> ShInputTexCoord2fs;
typedef ShTexCoord<2, SH_OUTPUT, ShFracShort> ShOutputTexCoord2fs;
typedef ShTexCoord<2, SH_INOUT, ShFracShort> ShInOutTexCoord2fs;
typedef ShTexCoord<2, SH_TEMP, ShFracShort> ShTexCoord2fs;
typedef ShTexCoord<2, SH_CONST, ShFracShort> ShConstTexCoord2fs;
typedef ShTexCoord<3, SH_INPUT, ShFracShort> ShInputTexCoord3fs;
typedef ShTexCoord<3, SH_OUTPUT, ShFracShort> ShOutputTexCoord3fs;
typedef ShTexCoord<3, SH_INOUT, ShFracShort> ShInOutTexCoord3fs;
typedef ShTexCoord<3, SH_TEMP, ShFracShort> ShTexCoord3fs;
typedef ShTexCoord<3, SH_CONST, ShFracShort> ShConstTexCoord3fs;
typedef ShTexCoord<4, SH_INPUT, ShFracShort> ShInputTexCoord4fs;
typedef ShTexCoord<4, SH_OUTPUT, ShFracShort> ShOutputTexCoord4fs;
typedef ShTexCoord<4, SH_INOUT, ShFracShort> ShInOutTexCoord4fs;
typedef ShTexCoord<4, SH_TEMP, ShFracShort> ShTexCoord4fs;
typedef ShTexCoord<4, SH_CONST, ShFracShort> ShConstTexCoord4fs;


typedef ShTexCoord<1, SH_INPUT, ShFracInt> ShInputTexCoord1fi;
typedef ShTexCoord<1, SH_OUTPUT, ShFracInt> ShOutputTexCoord1fi;
typedef ShTexCoord<1, SH_INOUT, ShFracInt> ShInOutTexCoord1fi;
typedef ShTexCoord<1, SH_TEMP, ShFracInt> ShTexCoord1fi;
typedef ShTexCoord<1, SH_CONST, ShFracInt> ShConstTexCoord1fi;
typedef ShTexCoord<2, SH_INPUT, ShFracInt> ShInputTexCoord2fi;
typedef ShTexCoord<2, SH_OUTPUT, ShFracInt> ShOutputTexCoord2fi;
typedef ShTexCoord<2, SH_INOUT, ShFracInt> ShInOutTexCoord2fi;
typedef ShTexCoord<2, SH_TEMP, ShFracInt> ShTexCoord2fi;
typedef ShTexCoord<2, SH_CONST, ShFracInt> ShConstTexCoord2fi;
typedef ShTexCoord<3, SH_INPUT, ShFracInt> ShInputTexCoord3fi;
typedef ShTexCoord<3, SH_OUTPUT, ShFracInt> ShOutputTexCoord3fi;
typedef ShTexCoord<3, SH_INOUT, ShFracInt> ShInOutTexCoord3fi;
typedef ShTexCoord<3, SH_TEMP, ShFracInt> ShTexCoord3fi;
typedef ShTexCoord<3, SH_CONST, ShFracInt> ShConstTexCoord3fi;
typedef ShTexCoord<4, SH_INPUT, ShFracInt> ShInputTexCoord4fi;
typedef ShTexCoord<4, SH_OUTPUT, ShFracInt> ShOutputTexCoord4fi;
typedef ShTexCoord<4, SH_INOUT, ShFracInt> ShInOutTexCoord4fi;
typedef ShTexCoord<4, SH_TEMP, ShFracInt> ShTexCoord4fi;
typedef ShTexCoord<4, SH_CONST, ShFracInt> ShConstTexCoord4fi;


typedef ShTexCoord<1, SH_INPUT, unsigned int> ShInputTexCoord1ui;
typedef ShTexCoord<1, SH_OUTPUT, unsigned int> ShOutputTexCoord1ui;
typedef ShTexCoord<1, SH_INOUT, unsigned int> ShInOutTexCoord1ui;
typedef ShTexCoord<1, SH_TEMP, unsigned int> ShTexCoord1ui;
typedef ShTexCoord<1, SH_CONST, unsigned int> ShConstTexCoord1ui;
typedef ShTexCoord<2, SH_INPUT, unsigned int> ShInputTexCoord2ui;
typedef ShTexCoord<2, SH_OUTPUT, unsigned int> ShOutputTexCoord2ui;
typedef ShTexCoord<2, SH_INOUT, unsigned int> ShInOutTexCoord2ui;
typedef ShTexCoord<2, SH_TEMP, unsigned int> ShTexCoord2ui;
typedef ShTexCoord<2, SH_CONST, unsigned int> ShConstTexCoord2ui;
typedef ShTexCoord<3, SH_INPUT, unsigned int> ShInputTexCoord3ui;
typedef ShTexCoord<3, SH_OUTPUT, unsigned int> ShOutputTexCoord3ui;
typedef ShTexCoord<3, SH_INOUT, unsigned int> ShInOutTexCoord3ui;
typedef ShTexCoord<3, SH_TEMP, unsigned int> ShTexCoord3ui;
typedef ShTexCoord<3, SH_CONST, unsigned int> ShConstTexCoord3ui;
typedef ShTexCoord<4, SH_INPUT, unsigned int> ShInputTexCoord4ui;
typedef ShTexCoord<4, SH_OUTPUT, unsigned int> ShOutputTexCoord4ui;
typedef ShTexCoord<4, SH_INOUT, unsigned int> ShInOutTexCoord4ui;
typedef ShTexCoord<4, SH_TEMP, unsigned int> ShTexCoord4ui;
typedef ShTexCoord<4, SH_CONST, unsigned int> ShConstTexCoord4ui;



} // namespace SH
#include "ShTexCoordImpl.hpp"

#endif // SH_SHTEXCOORD_HPP
